<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

/** 
 * Table of Contents
 * 
 * 1. Shortcode
 * 2. Elementor Widget Creator
 * 3. Optional: WPBakery Mapping
 */

//1. Shortcode
function hdfaf_builder($params, $content) {
    extract( shortcode_atts( 
        array(
        	'page_builder'               => '',
            'submit_button_label'        => '',
            'affiliate_form_action_url'  => '',
            'color'  				     => '',
            'placeholder'  				 => '',
            'domain_search'  			 => '',
            'value'  			 		 => '',
            'btn_color'  			 	 => '',
            'label'  			 		 => '',

        ), $params ) ); 

    	// CSS
   		wp_enqueue_style( 'hdfaf-custom', plugins_url( 'assets/css/custom.css', __FILE__ ), array(), '1.0.0', 'all' );
    	wp_enqueue_style( 'jquery-ui', plugins_url( 'assets/css/jquery-ui.css', __FILE__ ), array(), '1.0.0', 'all' );

	    ob_start(); 

		$domain_search_value = get_option('domain_search_option_name'); 
		$options = [
		    'com'     => esc_html__('.com', 'hdfaf'),
		    'net'     => esc_html__('.net', 'hdfaf'),
		    'org'     => esc_html__('org', 'hdfaf'),
		    'online'  => esc_html__('.online', 'hdfaf'),
		    'site'    => esc_html__('.site', 'hdfaf'),
		    'website' => esc_html__('.website', 'hdfaf'),
		    'space'   => esc_html__('.space', 'hdfaf'),
		    'tech'    => esc_html__('.tech', 'hdfaf'),
		    'store'   => esc_html__('.store', 'hdfaf'),
		    'co'      => esc_html__('.co', 'hdfaf'),
		    'blog'    => esc_html__('.blog', 'hdfaf'),
		    'me'      => esc_html__('.me', 'hdfaf'),
		    'info'    => esc_html__('.info', 'hdfaf'),
		    'biz'     => esc_html__('.biz', 'hdfaf'),
		    'us'      => esc_html__('.us', 'hdfaf'),
		    'ca'      => esc_html__('.ca', 'hdfaf'),
		    'life'    => esc_html__('.life', 'hdfaf'),
		    'cloud'   => esc_html__('.cloud', 'hdfaf'),
		];
		#value
        $value = '';
        if (isset($value) && !empty($value)) {
            $value = $value;
        }
	    ?> 
		    <div class="mt--hdfaf">  
			    <form action="<?php echo esc_url($affiliate_form_action_url); ?>" method="get" id="iffiliatesearch">
			    	<div class="row mt-hdfaf">
						<?php if ($page_builder == 'elementor' && $affiliate_form_action_url == 'https://www.bluehost.com/registration/?') { ?>
						    <div class="mt-hdfaf col-sm-8">
						        <input class="form-control" value="<?php echo esc_attr($value); ?>" name="search" type="text" placeholder="<?php echo esc_attr($placeholder); ?>">
						    </div>
							<?php if ($page_builder == 'elementor' && $domain_search == 'yes') { ?>
							    <div class="mt-hdfaf-search col-sm-2">
							        <select name="tld" id="tld">
							            <?php
							            foreach ($options as $value => $label) {
							                printf('<option value="%s" %s>%s</option>',
							                    esc_attr($value),
							                    selected($domain_search_value, $value, false),
							                    esc_html($label)
							                );
							            }
							            ?>
							        </select>
							    </div>
							<?php } ?>
						<?php } elseif ($page_builder == 'elementor' && $affiliate_form_action_url == 'https://www.namecheap.com/domains/registration/results/?') { ?>
						    <div class="mt-hdfaf col-sm-8">
						        <input class="form-control" value="<?php echo esc_attr($value); ?>" name="domain" type="text" placeholder="<?php echo esc_attr($placeholder); ?>">
						    </div>
						<?php } elseif ($page_builder == 'elementor' && $affiliate_form_action_url == 'https://www.godaddy.com/en-uk/domainsearch/find?') { ?>
						    <div class="mt-hdfaf col-sm-8">
						        <input class="form-control" value="<?php echo esc_attr($value); ?>" name="domainToCheck" type="text" placeholder="<?php echo esc_attr($placeholder); ?>">
						    </div>
						<?php }  ?>
		    			<div class="mt-hdfaf-botton col-md-2">
							<input type="submit" class="rippler rippler-default button-winona btn btn-lg tabs_button" style="background-color:<?php echo esc_attr($color); ?>; color:<?php echo esc_attr($btn_color); ?>;" domain="submit" domain="submit" tld="<?php echo esc_attr($label); ?>" value="<?php echo esc_attr($submit_button_label); ?>" />
						</div>
					</div>
				</form>
			</div>
	    <?php
	    return ob_get_clean();

	    //JS
    wp_enqueue_script( 'bootstrap-min', plugins_url( 'assets/js/bootstrap/bootstrap.min.js', __FILE__ ), array('jquery'), '1.0.0', true );
    wp_enqueue_script( 'bootstrap-css', plugins_url( 'assets/js/bootstrap/bootstrap.min.css', __FILE__ ), array('jquery'), '1.0.0', true );
	}
add_shortcode('hdfaf-builder-shortcode', 'hdfaf_builder');


// 2. Elementor Widget Creator
if (in_array('elementor/elementor.php', apply_filters('active_plugins', get_option('active_plugins')))) {
	class HDFAF_Elementor_Widgets {

		protected static $instance = null;

		public static function get_instance() {
			if ( ! isset( static::$instance ) ) {
				static::$instance = new static;
			}

			return static::$instance;
		}

		protected function __construct() {
			require_once('elementor.php');

			add_action( 'elementor/widgets/widgets_registered', [ $this, 'register_widgets' ] );
		}

		public function register_widgets() {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new \Elementor\HDFAF_Widget() );
		}

	}

	// Elementor Init
	add_action( 'init', 'hdfaf_elementor_init' );
	function hdfaf_elementor_init() {
		HDFAF_Elementor_Widgets::get_instance();
	}

	// Elementor Widgets Category
	function hdfaf_widget_categories( $elements_manager ) {
		$elements_manager->add_category(
			'modeltheme-affiliate-widgets',
			[
				'title' => esc_html__( 'ModelTheme Affiliate Forms', 'hdfaf' ),
				'icon' => 'fas fa-plug',
			]
		);
	}
	add_action( 'elementor/elements/categories_registered', 'hdfaf_widget_categories' );
}